<?php

namespace Shirtworks\Qute\Workflow;

use Exception;
use Litepie\Workflow\Exceptions\WorkflowActionNotPerformedException;

use Shirtworks\Qute\Models\Qutes;

class QutesAction
{
    /**
     * Perform the complete action.
     *
     * @param Qutes $qutes
     *
     * @return Qutes
     */
    public function complete(Qutes $qutes)
    {
        try {
            $qutes->status = 'complete';
            return $qutes->save();
        } catch (Exception $e) {
            throw new WorkflowActionNotPerformedException();
        }
    }

    /**
     * Perform the verify action.
     *
     * @param Qutes $qutes
     *
     * @return Qutes
     */public function verify(Qutes $qutes)
    {
        try {
            $qutes->status = 'verify';
            return $qutes->save();
        } catch (Exception $e) {
            throw new WorkflowActionNotPerformedException();
        }
    }

    /**
     * Perform the approve action.
     *
     * @param Qutes $qutes
     *
     * @return Qutes
     */public function approve(Qutes $qutes)
    {
        try {
            $qutes->status = 'approve';
            return $qutes->save();
        } catch (Exception $e) {
            throw new WorkflowActionNotPerformedException();
        }
    }

    /**
     * Perform the publish action.
     *
     * @param Qutes $qutes
     *
     * @return Qutes
     */public function publish(Qutes $qutes)
    {
        try {
            $qutes->status = 'publish';
            return $qutes->save();
        } catch (Exception $e) {
            throw new WorkflowActionNotPerformedException();
        }
    }

    /**
     * Perform the archive action.
     *
     * @param Qutes $qutes
     *
     * @return Qutes
     */
    public function archive(Qutes $qutes)
    {
        try {
            $qutes->status = 'archive';
            return $qutes->save();
        } catch (Exception $e) {
            throw new WorkflowActionNotPerformedException();
        }
    }

    /**
     * Perform the unpublish action.
     *
     * @param Qutes $qutes
     *
     * @return Qutes
     */
    public function unpublish(Qutes $qutes)
    {
        try {
            $qutes->status = 'unpublish';
            return $qutes->save();
        } catch (Exception $e) {
            throw new WorkflowActionNotPerformedException();
        }
    }
}
